//+------------------------------------------------------------------+
//|                                   Probmeter Trend Trading EA.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double lots=0.01;
extern int magic=30;
extern int max6=6;
extern int sendmail=0;
extern double takeprofit=175;
extern double stoploss=10000;

double Mom_0, Mom_1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int ticket,i,total;
   int j=0;
   string tf,text;
   double MyPoint=Point;
   if(Digits==3 || Digits==5) MyPoint=Point*10;
   
   total=OrdersTotal();
   
      
   
   for(i=0;i<total;i++)
   {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic) return(0);
   }
   
   if(max6==1)
   {
      for(i=0;i<OrdersHistoryTotal();i++) 
      {
         OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && TimeDay(OrderOpenTime()) == TimeDay(TimeCurrent()))
         {
            j=j+1;
            if(j==6) return(0);
         }
      }
   } 
   
   for(i=0;i<OrdersHistoryTotal();i++) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic) 
      {
         if(Period()==1 && TimeMinute(OrderOpenTime())== Minute() && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==5 && Minute()-5<TimeMinute(OrderOpenTime()) && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==15 && Minute()-15<TimeMinute(OrderOpenTime()) && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==60 && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==240 && Hour()-4<TimeHour(OrderOpenTime()) && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==1440 && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==10080 && DayOfYear()-7<TimeDayOfYear(OrderOpenTime()) && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==43200 && TimeMonth(OrderOpenTime())==Month() && TimeYear(OrderOpenTime())==Year()) return(0);
      }
   }
   
   //BUY LOGIC HA2a<HA1a&&HA2>HA1
       if((iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,0)>iMA(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,0))
       &&(iMA(NULL,0,21,0,MODE_EMA,PRICE_CLOSE,0)>iMA(NULL,0,51,0,MODE_EMA,PRICE_CLOSE,0))
       &&(iMA(NULL,0,138,0,MODE_EMA,PRICE_CLOSE,0)>iMA(NULL,0,183,0,MODE_EMA,PRICE_CLOSE,0))) // Here is your open buy rule
   {
       ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,3,Ask-stoploss*10*Point,Ask+takeprofit*10*Point,"Probmeter Trend Trading EA",magic,0,Green);
       if(ticket<0)
       {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
       }
       if(Period()==1) tf="M1";
       if(Period()==5) tf="M5";
       if(Period()==15) tf="M15";
       if(Period()==60) tf="H1";
       if(Period()==240) tf="H4";
       if(Period()==1440) tf="D1";
       if(Period()==10080) tf="W1";
       if(Period()==43200) tf="MN";
       text = StringConcatenate("Probmeter Long Trade at ", tf," ",Symbol()); 
       if(sendmail==1) SendMail("Probmeter Long Trade", text);
       Alert("Trade at ",tf," ",Symbol());
   }
   
   //SELL LOGIC HA2a>HA1a&&HA2<HA1
      if((iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,0)<iMA(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,0))
      &&(iMA(NULL,0,14,0,MODE_EMA,PRICE_CLOSE,0)<iMA(NULL,0,51,0,MODE_EMA,PRICE_CLOSE,0))
      &&(iMA(NULL,0,51,0,MODE_EMA,PRICE_CLOSE,0)<iMA(NULL,0,138,0,MODE_EMA,PRICE_CLOSE,0))) // Here is your open sell rule
   {
     
      ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,3,Bid+stoploss*10*Point,Bid-takeprofit*10*Point,"Probmeter Trend Trading EA",magic,0,Red);
      if(ticket<0)
      {
        Print("OrderSend failed with error #",GetLastError());
        return(0);
      }
       if(Period()==1) tf="M1";
       if(Period()==5) tf="M5";
       if(Period()==15) tf="M15";
       if(Period()==60) tf="H1";
       if(Period()==240) tf="H4";
       if(Period()==1440) tf="D1";
       if(Period()==10080) tf="W1";
       if(Period()==43200) tf="MN";
       text = StringConcatenate("Probmeter Short Trade at ", tf," ",Symbol()); 
       if(sendmail==1) SendMail("Probmeter Short Trade", text);
       Alert("Trade at ",tf," ",Symbol());
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+